> ## Documentation Index
> Fetch the complete documentation index at: https://timelines.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Send Message to Chat

> Send a message into an existing WhatsApp chat or group specified by chat_id.



## OpenAPI

````yaml post /chats/{chat_id}/messages
openapi: 3.0.3
info:
  title: Timelines Public API
  description: >
    # Timelines Public API


    _Some API calls may utilize message sending quota or be subject to message
    sending rate limits as described below._


    ### Credit Utilization 
      - Sending a message via API consumes 1 credit from message sending quota.
      - Sending a message with non-empty text and attachment consumes 2 credits from message sending quota.
      - If a message cannot be sent (invalid or not connected to WhatsApp number, WhatsApp server error), message sending quota will be restored (usually within a couple of hours).
    ### Message sending rate
      - Messages will be sent with random delay of about 2 seconds between each two messages (to avoid WhatsApp spam detection mechanisms). Contact support@timelines.ai if you want to modify delay for your workspace (available on Business plan only).
      - If you exceed message sending frequency, messages be queued and sent out with delay. Each queued message will consume a message sending credit, so the number of queued messages cannot exceed the available quota.
      
    ### Authorization:
      - Copy API token from [Public API page](https://app.timelines.ai/integrations/api/) in your TimelinesAI account.
      - Put the token in *Authorization* header of request as follows:
      ```
      Authorization: Bearer 4d2d0239-e28c-4f4a-8a4d-3a3ca40056b8
      ```
            
    ### Message formatting:
      - use "\n" for line breaks
  version: 1.3.0
servers:
  - url: /integrations/api
    description: Public API root URL
security:
  - bearerAuth: []
paths:
  /chats/{chat_id}/messages:
    post:
      summary: Send message in existing chat
      description: >-
        Send message into existing WhatsApp chat (or group) specified by
        chat_id. No need to specify WhatsApp Account, as each chat is already
        connected to a specific WhatsApp account in the TimelinesAI workspace. A
        message may contain a plaintext body or an attachment or both.
      parameters:
        - $ref: '#/components/parameters/chat_id'
      requestBody:
        description: A JSON describing recipient and message payload.
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MessageWithReply'
      responses:
        '200':
          description: Message accepted for async sending
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MessageSendResponse'
        '400':
          $ref: '#/components/responses/BadRequestError'
        '401':
          $ref: '#/components/responses/UnauthorizedError'
        '403':
          $ref: '#/components/responses/AccessDenied'
        '404':
          $ref: '#/components/responses/NotFound'
components:
  parameters:
    chat_id:
      in: path
      name: chat_id
      schema:
        type: integer
      required: true
      description: >-
        an id of the chat as appears in TimelinesAI (can be found in the URL of
        the chat page, or in the payload of outbound webhook). _Supports sending
        messages to a group._
  schemas:
    MessageWithReply:
      allOf:
        - type: object
          properties:
            reply_to:
              type: string
              nullable: true
              description: >
                UID of the message this message replies to. Must reference a
                message in the same workspace and WhatsApp account. Null or
                empty string is ignored.
        - $ref: '#/components/schemas/Message'
    MessageSendResponse:
      type: object
      required:
        - status
        - data
      properties:
        status:
          type: string
          example: ok
          enum:
            - ok
            - error
        data:
          $ref: '#/components/schemas/MessageID'
    Message:
      type: object
      properties:
        text:
          type: string
          maxLength: 2000
          description: plain text message
          example: hello, world!
        file_uid:
          type: string
          description: attachment UID
          example: afa9d4dd-978d-4a14-aa1b-bd65c272e645
        label:
          $ref: '#/components/schemas/Label'
        chat_name:
          type: string
          maxLength: 256
          description: an exact name of the chat (or group) as appears in TimelinesAI)
          example: MyChat
        attachment_template_id:
          type: integer
          description: >-
            a template ID of the attachment to be sent. The template must be
            created in the workspace before sending a message with it.
          example: 123456
    MessageID:
      type: object
      required:
        - message_uid
      properties:
        message_uid:
          type: string
    ErrorResponse:
      required:
        - message
        - status
      type: object
      properties:
        message:
          type: string
        status:
          type: string
          example: error
          enum:
            - ok
            - error
        error_code:
          type: string
          description: >-
            Stable, machine-readable error code. Use this for branching in
            client integrations.
          example: validation_error
          enum:
            - missing_credentials
            - invalid_token
            - member_not_found
            - permission_denied
            - plan_feature_unavailable
            - quota_exceeded
            - rate_limit_exceeded
            - validation_error
            - not_supported
            - internal_error
        errors:
          type: array
          description: >-
            Per-field validation diagnostics. Present on `validation_error`
            responses; absent on auth/authorization/quota errors.
          items:
            $ref: '#/components/schemas/ValidationError'
    Label:
      type: string
      maxLength: 64
      description: >-
        assign label to the chat, in which the message is sent (create new
        label, if not exists)
      example: customer
    ValidationError:
      type: object
      required:
        - fields
        - msg
      properties:
        fields:
          type: array
          items:
            type: string
          description: >-
            Path of the offending field, as a list of keys/indexes from the
            request root.
          example:
            - url
        msg:
          type: string
          description: Validator message for that field.
          example: must be a valid http(s) URL
  responses:
    BadRequestError:
      description: Invalid parameters
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    UnauthorizedError:
      description: Access token is missing or invalid
    AccessDenied:
      description: Access denied
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    NotFound:
      description: Specified entities not found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````